Imports System.Math
Module Affichage_Note_de_Calcul
    Friend WithEvents ThisApplication As Word.Application
    Friend WithEvents ThisDocument As Word.Document
    Private selTextSelectionne As Word.Selection
    Private cDerniereLettre As Char
    Public Sub Note_de_calcul()
        Try
            CreationDocument()
            InitialisationDocument()
            EcrireFichier()
            'Affiche Word
            ThisApplication.Visible = True

        Catch ex As Exception
            If Err.Number = 5825 Then
                'Normal => Objet Word detruit (surement du a la fermeture du formulaire pendant l'execution)
            Else
                DestructionDocument()
                Throw ex
            End If
        End Try
    End Sub
    Private Sub CreationDocument()
        'rtbEtat.AppendText("Cration de l'application word et du document." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        DestructionDocument() 'Detruit les variabble pour ne pas cr de document orphelin si on clique 2 fois sur le bouton
        ThisApplication = New Word.Application
        ThisApplication.Visible = False 'Masque Word
        ThisDocument = ThisApplication.Documents.Add 'Ajoute un document
    End Sub
    Private Sub InitialisationDocument()
        'rtbEtat.AppendText("Mise en forme du document Word." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        ThisDocument.Range.Font.Name = "arial" 'Defini la police de caractre
        ThisDocument.PageSetup.TextColumns.SetCount(1) 'Impose 1 colonnes au document
        'ThisDocument.PageSetup.TextColumns.LineBetween = CInt(True) 'Insert une ligne verticale entre chaque colonne
        ThisDocument.PageSetup.OddAndEvenPagesHeaderFooter = CInt(True) 'Indique que les Pages paires et impaires seront traites diffrement (pour les entetes et pieds de page ici)

        'Definit les entetes des pages paires
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Text = "Poteau en bton arm: note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10

        'Definit les entetes des pages impaires
        'les 2 tabulation aligne automatique le texte a droite sur les TabStop Automatique de Word (le premier est un centrage)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Text = vbTab & vbTab & "Note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Definit les entetes des pages paires et impaire
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Ajoute les numro de page sur l'exterieus des page dans les pied de page
        'Force le redemarrage du comptage de la section (ici une seule section celle par default donc tous le docuemnt)
        'Le redemarrage commence a 34
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.Add(Word.WdPageNumberAlignment.wdAlignPageNumberOutside)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.RestartNumberingAtSection = True
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.StartingNumber = 1

        ThisDocument.Range.Select() 'Defini "selTextSelectionne" comme une plage recouvrant tout le document
        selTextSelectionne = ThisApplication.Selection
    End Sub
    Private Sub DestructionDocument()
        'rtbEtat.AppendText("Destruction des objets utiliss" & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        Application.DoEvents()

        If Not (ThisApplication Is Nothing) Then
            Try
                'Ferme l'application sans enregistr le document
                ThisApplication.Quit(Word.WdSaveOptions.wdDoNotSaveChanges)
            Catch ex As System.Runtime.InteropServices.COMException
                'l'application a t ferm par l'utilisateur
            End Try
        End If
        'tbDonnees = Nothing
        ThisDocument = Nothing
        ThisApplication = Nothing
    End Sub

    Private Sub EcrireFichier()
        Dim str, F1, F2, F3, F4, F5, F6, F7 As String
        Dim i, i1, i2, j As Integer

        'VerifeNouvelleLetre(Mid(tbDonnees(nIndex).sNom, 1, 1))

        'Dim dbutSlection As Integer = selTextSelectionne.Range.Start
        'selTextSelectionne.TypeText(tbDonnees(nIndex))

        'Mesure des tabstops => 1000 point = 352.7 mm
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count).TabStops.Add((1000 / 352.7 * 75), Word.WdTabAlignment.wdAlignTabRight)
        selTextSelectionne.TypeText(vbTab)

        selTextSelectionne.TypeText("Note de Calcul")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = 0
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Color = Word.WdColor.wdColorBlue
        'ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 14
        selTextSelectionne.TypeText(vbCrLf)

        str = "I - Etat Limite Ultime de Rsistance :"
        selTextSelectionne.TypeText(Str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)


        str = "I-1 - Dimension de la semelle et vrification des contraintes sur le sol" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim Vent As Boolean
        Dim F_q133$, F_smax$, F_nsmax$, msg$
        F_a = Format(a, "#0.00") : F_h = Format(h, "#0.00")
        F_q = Format(q, "#0.000") : F_q133 = Format(q * 1.33, "#0.000")
        F_smax = Format(smax, "#0.000") : F_nsmax = Format(nsmax, "##")
        Select Case geom
            Case 1 'semelle isole
                F_b = Format(b, "#0.00")
                If a = b Then msg = "carre" Else msg = "rectangulaire"
                str = " Semelle " & msg & " de dimension " & F_a & " m " & "x" & F_b & " m" : Affichage(str)
                str = " hauteur : " & F_h & " m" : Affichage(str)
                str = "combinaison la plus dfavorable n " & F_nsmax & " (ELU)" : Affichage(str)
                If calcc(1) = 2 Or calcc(2) = 2 Then
                    Vent = False
                    For i = 1 To 4
                        If comb(1, i) = 1 Then Vent = True
                    Next i
                    If Vent = True Then
                        msg = "p = " & F_smax & " < 1.33xq = " & F_q133 & " MPa" & " ---> OK" : Affichage(msg) 'combinaison avec vent
                    Else
                        msg = "p = " & F_smax & " < q = " & F_q & " MPa" & " ---> OK" : Affichage(msg)
                    End If
                Else
                    msg = "Semelle sous charge verticale centre" : Affichage(msg)
                    msg = "La contrainte du sol est rpartie uniformment sous la semelle. Celle-ci vaut :" : Affichage(msg)
                    msg = "p = " & F_smax & " < q = " & F_q & " MPa" & " ---> OK" : Affichage(msg)     'combinaison sans vent
                End If

            Case 2 'semelle filante
                str = " Semelle filante de largeur " & F_a & " m " : Affichage(str)
                str = " hauteur : " & F_h & " m" : Affichage(str)
                str = "combinaison la plus dfavorable n " & F_nsmax & " (ELU)" : Affichage(str)
                If calcc(1) = 2 Or calcc(2) = 2 Then
                    Vent = False
                    For i = 1 To 4
                        If comb(1, i) = 1 Then Vent = True
                    Next i
                    If Vent = True Then
                        msg = "p = " & F_smax & " < 1.33xq = " & F_q133 & " MPa" & " ---> OK"  'combinaison avec vent
                    Else
                        msg = "p = " & F_smax & " < q = " & F_q & " MPa" & " ---> OK"
                    End If
                    Affichage(msg)
                Else
                    msg = "Semelle sous charge verticale centre" : Affichage(msg)
                    msg = "La contrainte du sol est rpartie uniformment sous la semelle." : Affichage(msg)
                    msg = "Celle-ci vaut :" : Affichage(msg)
                    msg = "p = " & F_smax & " < q = " & F_q & " MPa" & " ---> OK" : Affichage(msg)  'combinaison sans vent
                End If

            Case 3 'semelle filante non arme
                str = " Semelle filante non arme :" : Affichage(str)
                str = "de largeur " & F_a & " m. et hauteur : " & F_h & " m." : Affichage(str)
                str = "combinaison la plus dfavorable n " & F_nsmax & " (ELU)" : Affichage(str)
                str = "Semelle sous charge verticale centre" : Affichage(str)
                str = "La contrainte du sol est rpartie uniformment sous la semelle." : Affichage(str)
                str = "Celle-ci vaut :" : Affichage(str)
                str = "p = " & F_smax & " < q = " & F_q & " MPa" & " ---> OK" : Affichage(str)  'combinaison sans vent

        End Select
        selTextSelectionne.TypeText(vbCrLf)
        '
        '--------> Paragraphe I-2
        '
        str = "I-2 - Calcul section acier bas semelle" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim asaa, asbb, asa1, asa2, asb1, asb2, mamax, mbmax As Double
        Dim F_assa$, F_asaa$, F_asbb$, F_assb$, F_espa$, F_espb$, F_mamax$, F_mbmax$, F_nbarA$
        Dim F_nbarB$, F_phiA$, F_phiB$, msg1$, msg2$
        Dim espacement_transversal() As Integer = {200, 300, 300, 300, 300, 300, 300, 200, 150, 100, 100}
        Dim nom_TS() As String = {"ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 45", "ST 50", "ST 60", "ST 25C", "ST 40C", "ST 65C"}
        Dim section_longitudinale() As Single = {1.19, 1.88, 2.57, 2.83, 3.85, 4.24, 5.03, 6.36, 2.57, 3.85, 6.36}
        Dim section_transversale() As Single = {1.19, 1.28, 1.28, 1.28, 1.28, 1.68, 1.68, 2.51, 2.57, 3.85, 6.36}
        F_assa = Format(assa * 10000, "#0.00") : F_assb = Format(assb * 10000, "#0.00")
        asaa = CSng(nbarA * ((phiA) ^ 2) * PI / 4)  ' en m2
        asbb = CSng(nbarB * ((phib) ^ 2) * PI / 4)
        F_asaa = Format(asaa * 10000, "#0.00") : F_asbb = Format(asbb * 10000, "#0.00")
        F_espa = Format(espa * 100, "#0.0") : F_espb = Format(espb * 100, "#0.0")
        F_nbarA = Format(nbarA, "##") : F_nbarB = Format(nbarB, "##")
        F_phiA = Format(phiA * 1000, "##") : F_phiB = Format(phib * 1000, "##")
        If calcc(1) = 2 And calcc(2) = 2 Then
            mamax = ms1(nasacomb) : mbmax = ms1(nasbcomb)
        Else
            If calcc(1) = 2 Then mamax = ms1(nasacomb)
            If calcc(2) = 2 Then mbmax = ms1(nasbcomb)
        End If
        For i = 1 To 4 : F_p(1, i) = Format(p(1, i), "#0.000") : Next i
        If calcc(1) = 1 And calcc(2) = 1 Then
            Select Case geom
                Case 1  'semelle isole
                    Select Case Type_acier
                        Case 1 'TS
                            Select Case nbLit
                                Case 1  '1 lit
                                    msg = nom_TS(NLit_TS(1))
                                    asaa = section_longitudinale(NLit_TS(1))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(1))
                                    F_asbb = Format(asbb, "#0.00")
                                    msg1 = "Suivant mthode des bielles :" : Affichage(msg1)
                                    msg1 = " charge verticale maximale = " & F_p(1, nsmax) & " MN" : Affichage(msg1)
                                    msg1 = " Soit //  A : As = " & F_assa & " cm2 et //  B : As = " & F_assb & " cm2" : Affichage(msg1)
                                    msg = "---> prvu un treillis souds:" & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(msg)
                                    asaa = asaa * b : asbb = asbb * a
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    msg = "pour un total de " & F_asaa & " cm2 //A et " & F_asbb & " cm2 //B" : Affichage(msg)
                                    If nbarB <> 0 Then str = "Renforc par " & F_nbarB & " HA" & F_phiB & " filant." : Affichage(str)

                                Case 2  '2 lits
                                    msg = "Suivant mthode des bielles :" : Affichage(msg)
                                    msg = " charge verticale maximale = " & F_p(1, nsmax) & " MN" : Affichage(msg)
                                    msg = " Soit //  A : As = " & F_assa & " cm2 et //  B : As = " & F_assb & " cm2" : Affichage(msg)
                                    msg = "---> prvu deux treillis souds:" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(2))
                                    asaa = section_longitudinale(NLit_TS(2))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(2))
                                    asa1 = asaa : asb1 = asbb
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    msg = " premier lit: " & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(3))
                                    asaa = section_longitudinale(NLit_TS(3))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(3))
                                    asa2 = asaa : asb2 = asbb
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    msg = " deuxime lit: " & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(msg)
                                    asaa = (asa1 + asa2) * b : asbb = (asb1 + asb2) * a
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    msg = "pour un total de " & F_asaa & " cm2 //A et " & F_asbb & " cm2 //B" : Affichage(msg)

                            End Select
                        Case 2 'HA
                            msg = "Suivant mthode des bielles :" : Affichage(msg)
                            msg = " charge verticale maximale = " & F_p(1, nsmax) & " MN" : Affichage(msg)
                            msg = " Soit suivant a : As = " & F_assa & " cm2 ---> prvu " & F_nbarA & " HA " & F_phiA & "  soit ( " & F_asaa & " cm2)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espa & " cm" : Affichage(msg)
                            msg = "        suivant b : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & "  soit ( " & F_asbb & " cm2)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espb & " cm" : Affichage(msg)

                    End Select
                Case 2 'semelle filante
                    Select Case Type_acier
                        Case 1 'TS
                            Select Case nbLit
                                Case 1  '1 lit
                                    asaa = section_longitudinale(NLit_TS(1))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(1))
                                    F_asbb = Format(asbb, "#0.00")
                                    msg = "Suivant mthode des bielles :" : Affichage(msg)
                                    msg = " charge verticale maximale = " & F_p(1, nsmax) & " MN/ml" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(1))
                                    msg = " Soit suivant a : As = " & F_assa & " cm2/ml ---> prvu un treillis soud  " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = " Dans le sens de la longueur de la semelle, le treillis soud est filant et reprsente une section de " & F_asbb & " cm2/m" : Affichage(msg)
                                    If nbarB <> 0 Then
                                        msg = "Renforc par " & F_nbarB & " HA" & F_phiB & " filant." : Affichage(msg)
                                    End If
                                Case 2  '2 lits
                                    msg = "Suivant mthode des bielles :" : Affichage(msg)
                                    msg = " charge verticale maximale = " & F_p(1, nsmax) & " MN/ml" : Affichage(msg)
                                    msg = " Soit suivant a : As = " & F_assa & " cm2/ml ---> prvu deux treillis souds:" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(2))
                                    asaa = section_longitudinale(NLit_TS(2))
                                    F_asaa = Format(asaa, "#0.00")
                                    msg = " premier lit: " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(3))
                                    asaa = section_longitudinale(NLit_TS(3))
                                    F_asaa = Format(asaa, "#0.00")
                                    msg = " deuxime lit: " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = " Dans le sens de la longueur de la semelle, les treillis souds sont superposs et filants." : Affichage(msg)

                            End Select
                        Case 2 'HA
                            msg = "Suivant mthode des bielles :" : Affichage(msg)
                            msg = " charge verticale maximale = " & F_p(1, nsmax) & " MN/ml" : Affichage(msg)
                            msg = " Soit suivant a : As = " & F_assa & " cm2/ml ---> prvu " & F_nbarA & " HA " & F_phiA & " /ml ( " & F_asaa & " cm2/ml)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espa & " cm" : Affichage(msg)
                            msg = "        suivant b : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & "  soit ( " & F_asbb & " cm2)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espb & " cm" : Affichage(msg)

                    End Select
                Case 3 'semelle filante non arme
                    Select Case Type_acier
                        Case 1  'TS
                            asaa = section_longitudinale(NLit_TS(1))
                            F_asbb = Format(asaa, "#0.00")
                            msg = "Chainage de principe suivant article 2,53 du DTU 13.12 :" : Affichage(msg)
                            msg = nom_TS(NLit_TS(1))
                            msg = " Soit : As = " & F_assb & " cm2 ---> prvu un treillis soud  " & msg & " ( " & F_asbb & " cm2 sur la largeur de la semelle)" : Affichage(msg)

                        Case 2  'HA
                            msg = "Chainage de principe suivant article 2,53 du DTU 13.12 :" : Affichage(msg)
                            msg = " Soit : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & " ( " & F_asbb & " cm2)" : Affichage(msg)

                    End Select
            End Select

        Else
            Select Case geom
                Case 1  'semelle isole
                    Select Case Type_acier
                        Case 1 'TS
                            Select Case nbLit
                                Case 1  '1 lit
                                    msg = nom_TS(NLit_TS(1))
                                    asaa = section_longitudinale(NLit_TS(1))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(1))
                                    F_asbb = Format(asbb, "#0.00")
                                    str = "Suivant mthode des bielles :" : Affichage(str)
                                    str = " charge verticale maximale = " & F_p(1, nsmax) & " MN" : Affichage(str)
                                    str = " Soit //  A : As = " & F_assa & " cm2 et //  B : As = " & F_assb & " cm2" : Affichage(str)
                                    str = "---> prvu un treillis souds:" & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(str)
                                    asaa = asaa * b : asbb = asbb * a
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    str = "pour un total de " & F_asaa & " cm2 //A et " & F_asbb & " cm2 //B" : Affichage(str)

                                    If nbarB <> 0 Then
                                        str = "Renforc par " & F_nbarB & " HA" & F_phiB & " filant." : Affichage(str)
                                    End If
                                Case 2  '2 lits
                                    str = "Suivant mthode des bielles :" : Affichage(str)
                                    str = " charge verticale maximale = " & F_p(1, nsmax) & " MN" : Affichage(str)
                                    str = " Soit //  A : As = " & F_assa & " cm2 et //  B : As = " & F_assb & " cm2" : Affichage(str)
                                    str = "---> prvu deux treillis souds:" : Affichage(str)
                                    msg = nom_TS(NLit_TS(2))
                                    asaa = section_longitudinale(NLit_TS(2))
                                    asbb = section_transversale(NLit_TS(2))
                                    asa1 = asaa : asb1 = asbb
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    str = " premier lit: " & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(str)
                                    msg = nom_TS(NLit_TS(3))
                                    asaa = section_longitudinale(NLit_TS(3))
                                    asbb = section_transversale(NLit_TS(3))
                                    asa2 = asaa : asb2 = asbb
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    str = " deuxime lit: " & msg & " (//A  " & F_asaa & " cm2/m et //B " & F_asbb & " cm2/m)" : Affichage(str)
                                    asaa = (asa1 + asa2) * b : asbb = (asb1 + asb2) * a
                                    F_asaa = Format(asaa, "#0.00") : F_asbb = Format(asbb, "#0.00")
                                    str = "pour un total de " & F_asaa & " cm2 //A et " & F_asbb & " cm2 //B" : Affichage(str)

                            End Select
                        Case 2 'HA
                            If calcc(1) = 2 Then
                                F_mamax = Format(mamax, "#0.000")
                                str = "Suivant mthode des poutres pour les aciers //  A:" : Affichage(str)
                                str = " Moment Max. suivant a = " & F_mamax & " MN.m" : Affichage(str)
                                str = " Soit suivant a : As = " & F_assa & " cm2 ---> prvu " & F_nbarA & " HA " & F_phiA & "  soit ( " & F_asaa & " cm2)" : Affichage(str)
                                str = "                  espacement entre aciers : " & F_espa & " cm" : Affichage(str)
                                str = "Suivant mthode des bielles pour les aciers //  B:" : Affichage(str)
                                str = " charge verticale maximale = " & F_p(1, nasbcomb) & " MN" : Affichage(str)
                                str = " Soit suivant B : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & "  soit ( " & F_asbb & " cm2)" : Affichage(str)
                                str = "                  espacement entre aciers : " & F_espb & " cm" : Affichage(str)

                            Else
                                F_mbmax = Format(mbmax, "#0.000")
                                str = "Suivant mthode des poutres pour les aciers //  B:" : Affichage(str)
                                str = " Moment Max. suivant b = " & F_mbmax & " MN.m" : Affichage(str)
                                str = " Soit suivant B : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & "  soit ( " & F_asbb & " cm2)" : Affichage(str)
                                str = "                  espacement entre aciers : " & F_espb & " cm" : Affichage(str)
                                str = "Suivant mthode des bielles pour les aciers //  A:" : Affichage(str)
                                str = " charge verticale maximale = " & F_p(1, nasacomb) & " MN" : Affichage(str)
                                str = " Soit suivant A : As = " & F_assa & " cm2 ---> prvu " & F_nbarA & " HA " & F_phiA & "  soit ( " & F_asaa & " cm2)" : Affichage(str)
                                str = "                  espacement entre aciers : " & F_espa & " cm" : Affichage(str)

                            End If
                    End Select
                Case 2 'semelle filante
                    F_mamax = Format(mamax, "#0.000")
                    Select Case Type_acier
                        Case 1 'TS
                            Select Case nbLit
                                Case 1  '1 lit
                                    msg = nom_TS(NLit_TS(1))
                                    asaa = section_longitudinale(NLit_TS(1))
                                    F_asaa = Format(asaa, "#0.00")
                                    asbb = section_transversale(NLit_TS(1))
                                    F_asbb = Format(asbb, "#0.00")
                                    msg = "Suivant mthode des poutres pour les aciers //  A:" : Affichage(msg)
                                    msg = " Moment Max. suivant a = " & F_mamax & " MN.m/ml" : Affichage(msg)
                                    msg = " Soit suivant a : As = " & F_assa & " cm2/ml ---> prvu un treillis soud  " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = " Dans le sens de la longueur de la semelle, le treillis soud est filant et reprsente une section de " & F_asbb & " cm2/m" : Affichage(msg)
                                    If nbarB <> 0 Then
                                        msg = "Renforc par " & F_nbarB & " HA" & F_phiB & " filant." : Affichage(msg)
                                    End If
                                Case 2  '2 lits
                                    msg = "Suivant mthode des poutres pour les aciers //  A:" : Affichage(msg)
                                    msg = " Moment Max. suivant a = " & F_mamax & " MN.m/ml" : Affichage(msg)
                                    msg = " Soit suivant a : As = " & F_assa & " cm2/ml ---> prvu deux treillis souds:" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(2))
                                    asaa = section_longitudinale(NLit_TS(2))
                                    F_asaa = Format(asaa, "#0.00")
                                    msg = " premier lit: " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = nom_TS(NLit_TS(3))
                                    asaa = section_longitudinale(NLit_TS(3))
                                    F_asaa = Format(asaa, "#0.00")
                                    msg = " deuxime lit: " & msg & " ( " & F_asaa & " cm2/m)" : Affichage(msg)
                                    msg = " Dans le sens de la longueur de la semelle, les treillis souds sont superposs et filants." : Affichage(msg)

                            End Select
                        Case 2 'HA
                            msg = "Suivant mthode des poutres pour les aciers //  A:" : Affichage(msg)
                            msg = " Moment Max. suivant a = " & F_mamax & " MN.m" : Affichage(msg)
                            msg = " Soit suivant A : As = " & F_assa & " cm2 ---> prvu " & F_nbarA & " HA " & F_phiA & "  soit ( " & F_asaa & " cm2)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espa & " cm" : Affichage(msg)
                            msg = " Dans le sens de la longueur de la semelle, les aciers sont filants." : Affichage(msg)
                            msg = " Soit suivant B : As = " & F_assb & " cm2 ---> prvu " & F_nbarB & " HA " & F_phiB & "  soit ( " & F_asbb & " cm2)" : Affichage(msg)
                            msg = "                  espacement entre aciers : " & F_espb & " cm" : Affichage(msg)

                    End Select
            End Select
        End If
        Select Case geom
            Case 1  'semelle isole
                If iretA = 0 And iretB = 0 Then
                    str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits mais ne comportent pas de crochets" : Affichage(str)
                    str = "Suivant B :toutes les barres sont prolonges jusqu'aux extrmits mais ne comportent pas de crochets" : Affichage(str)
                ElseIf iretA = 0 And iretB <> 0 Then
                    str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits mais ne comportent pas de crochets" : Affichage(str)
                    str = "Suivant B :toutes les barres sont prolonges jusqu'aux extrmits et comportent des crochets" : Affichage(str)

                ElseIf iretA <> 0 And iretB = 0 Then
                    str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits et comportent des crochets" : Affichage(str)
                    str = "Suivant B :toutes les barres sont prolonges jusqu'aux extrmits mais ne comportent pas de crochets" : Affichage(str)
                ElseIf iretA <> 0 And iretB <> 0 Then
                    str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits et comportent des crochets" : Affichage(str)
                    str = "Suivant B :toutes les barres sont prolonges jusqu'aux extrmits et comportent des crochets" : Affichage(str)
                End If
            Case 2  'semelle filante
                Select Case Type_acier
                    Case 1 'ts
                        Select Case Icrochet
                            Case 1 ' avec crochet
                                str = "Suivant A :TS avec crochets aux extrmits" : Affichage(str)
                                str = "Suivant B : TS filants avec recouvrement entre panneaux" : Affichage(str)
                            Case 2 'sans crochet
                                str = "Suivant A :TS sans crochets aux extrmits" : Affichage(str)
                                str = "Suivant B : TS filants avec recouvrement entre panneaux" : Affichage(str)
                            Case 3 'disposition en portefeuille
                                str = "Suivant A :TS superposs et disposs en portefeuille" : Affichage(str)
                                str = "Suivant B : TS filants avec recouvrement entre panneaux" : Affichage(str)
                        End Select
                    Case 2  'HA
                        If iretA = 0 Then
                            str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits mais ne comportent pas de crochets" : Affichage(str)
                            str = "Suivant B : barres filantes avec recouvrement" : Affichage(str)
                        Else
                            str = "Suivant A :toutes les barres sont prolonges jusqu'aux extrmits et comportent des crochets" : Affichage(str)
                            str = "Suivant B : barres filantes avec recouvrement" : Affichage(str)
                        End If
                End Select
            Case 3  'semelle filante non arme
                Select Case Type_acier
                    Case 1 'ts
                        str = "Treilis soud filant avec recouvrement" : Affichage(str)
                    Case 2 'HA
                        str = "Suivant A :pas de barres " : Affichage(str)
                        str = "Suivant B : barres filantes avec recouvrement" : Affichage(str)
                End Select
        End Select

        selTextSelectionne.TypeText(vbCrLf)
        '
        '--------> Paragraphe I-3
        '
        str = "I-3 - Calcul section acier haut semelle" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim soulevement As Boolean
        Dim F_ha$, F_nbarAh$, F_nbarBh$, F_sigma_beton$, F_ft$
        Dim F_asaah$, F_asbbh$, F_phiAh$, F_phiBh$
        Dim F_assah$, F_assbh$
        Dim ft, asaah, asbbh As Single
        F_assah = Format(assah * 10000, "#0.00")
        F_assbh = Format(assbh * 10000, "#0.00")
        F_asaah = Format(asaah * 10000, "###.00") : F_asbbh = Format(asbbh * 10000, "###.00")
        F_phiAh = Format(phiAh * 1000, "###.00") : F_phiBh = Format(phiBh * 1000, "###.00")
        F_nbarAh = Format(nbarAh, "##")
        F_nbarBh = Format(nbarBh, "##")
        If sigma_beton = 0 Then
            soulevement = False
            For i = 1 To 4
                If mx(1, i) <> 0 Then soulevement = True : Exit For
                If mty(1, i) <> 0 Then soulevement = True : Exit For
            Next i
            If soulevement = False Then
                msg = "Sans objet ." : Affichage(msg)
                msg = "Aucun moment agissant. Pas de soulvement de la semelle ." : Affichage(msg)
            Else
                msg = "Le moment agissant n'est pas suffisant pour soulever la semelle" : Affichage(msg)
                msg = "La contrainte sur la fibre tendue de la section de bton rendue" : Affichage(msg)
                msg = "homogne de la semelle de fondation reste comprim. l'excentricit" : Affichage(msg)
                msg = " (e=N/M) est incluse dans le noyau central." : Affichage(msg)
            End If

        Else
            ft = CSng(0.6 + 0.06 * fc)
            F_sigma_beton = Format(sigma_beton, "#0.00") : F_ft = Format(ft, "##.00")
            msg = "Vous n'avez pas souhait de ferraillage en partie haute de la semelle." : Affichage(msg)
            msg = "Pour information, la contrainte de traction sur le bton tendu (section rendue" : Affichage(msg)
            msg = "homogne) est gale  " & F_sigma_beton & " MPa pour une valeur limite de " & F_ft & " MPa." : Affichage(msg)
            Select Case geom
                Case 1
                    msg = " Section Acier suprieur suivant A : As = " & F_assah & " cm2 ---> prvu " & F_nbarAh & " HA " & F_phiAh & "  soit ( " & F_asaah & " cm2)" : Affichage(msg)
                    msg = "Section Acier suprieur suivant B : As = " & F_assbh & " cm2 ---> prvu " & F_nbarBh & " HA " & F_phiBh & "  soit ( " & F_asbbh & " cm2)" : Affichage(msg)
                Case 2
                    msg = " Section Acier suprieur suivant A : As = " & F_assah & " cm2 ---> prvu " & F_nbarAh & " HA " & F_phiAh & "  soit ( " & F_asaah & " cm2)" : Affichage(msg)
                    msg = "Section Acier suprieur suivant B : As = " & F_assbh & " cm2 ---> prvu " & F_nbarBh & " HA " & F_phiBh & "  soit ( " & F_asbbh & " cm2)" : Affichage(msg)
            End Select
        End If
        selTextSelectionne.TypeText(vbCrLf)
        '
        '--------> Paragraphe I-4
        '
        str = "I-4 - Calcul section acier attentes du poteau" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim F_lc$, F_lc1$, F_nbha$, F_espVoile$
        F_lc = Format(lc, "##0.00")
        F_lc1 = Format(lc1 * 100, "##0")
        F_nbha = Format(nbha, "#0")
        Select Case geom
            Case 1 'semelle isole
                F_ha = Format(Ha * 1000, "#0")
                If moment = 1 Then
                    msg = "Les aciers longitudinaux d'attente du poteau sont prolongs " : Affichage(msg)
                    msg = "dans la semelle et sont retourns en partie basse de la " : Affichage(msg)
                    msg = "fondation par retour d'equerre d'une longueur de 35 fois " : Affichage(msg)
                    msg = "le diamtre . Cf DTU 13.12" : Affichage(msg)
                    msg = "Soit " & F_nbha & " HA " & F_ha & " x " & F_lc & " m : retour de " & F_lc1 & " cm" : Affichage(msg)
                Else
                    msg = "Les aciers longitudinaux d'attente du poteau sont prolongs " : Affichage(msg)
                    msg = "dans la semelle d'une longueur de 20 fois le diamtre ." : Affichage(msg)
                    msg = "Cf DTU 13.12" : Affichage(msg)
                    msg = "Soit " & F_nbha & " HA " & F_ha & " x " & F_lc & " m " : Affichage(msg)
                End If
            Case 2 'semelle filante arme
                If Attente = False Then
                    msg = "Pas d'aciers en attente dans la semelle filante " : Affichage(msg)
                Else
                    F_ha = Format(HAvoile * 1000, "#0") : F_espVoile = Format(espvoile * 100, "###")
                    msg = "Les aciers longitudinaux d'attente du voile sont prolongs dans la semelle filante " : Affichage(msg)
                    If moment = 1 Then
                        msg = "et sont retourns en partie basse de la fondation par retour d'equerre d'une longueur de 35 fois " : Affichage(msg)
                        msg = "le diamtre . Cf DTU 13.12 soit :" : Affichage(msg)
                        If Rang = 1 Then
                            msg = " HA " & F_ha & " x " & F_lc & " m  sur 1 rang avec retour de " & F_lc1 & " cm  esp=" & F_espVoile & " cm" : Affichage(msg)
                        Else
                            msg = " HA " & F_ha & " x " & F_lc & " m  sur 2 rangs avec retour de " & F_lc1 & " cm  esp=" & F_espVoile & " cm" : Affichage(msg)
                        End If
                    Else
                        msg = "d'une longueur de 20 fois le diamtre . Cf DTU 13.12  Soit :" : Affichage(msg)
                        If Rang = 1 Then
                            msg = " HA " & F_ha & " x " & F_lc & " m  sur 1 rang   esp=" & F_espVoile & " cm" : Affichage(msg)
                        Else
                            msg = " HA " & F_ha & " x " & F_lc & " m  sur 2 rangs   esp=" & F_espVoile & " cm" : Affichage(msg)
                        End If
                    End If
                End If

            Case 3  'semelle filante non arme
                Select Case Voile
                    Case 1, 2
                        If Attente = False Then
                            msg = "Pas d'aciers en attente dans la semelle filante " : Affichage(msg)
                        Else
                            F_ha = Format(HAvoile * 1000, "#0") : F_espVoile = Format(espvoile * 100, "###")
                            msg = "Aciers en attente dans la semelle filante pour la reprise du voile bton" : Affichage(msg)
                            msg = "Soit :" : Affichage(msg)
                            If Rang = 1 Then
                                msg = " HA " & F_ha & " x " & F_lc & " m  sur 1 rang  esp=" & F_espVoile & " cm" : Affichage(msg)
                            Else
                                msg = " HA " & F_ha & " x " & F_lc & " m  sur 2 rangs esp=" & F_espVoile & " cm" : Affichage(msg)
                            End If
                        End If
                    Case 3, 4
                        str = "Sans objet. Voile en maonnerie" : Affichage(str)
                End Select
        End Select
        selTextSelectionne.TypeText(vbCrLf)
        '
        '--------> Paragraphe I-5
        '
        str = "I-5 - Vrification du bton" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim F_ntaumax$
        Dim F_taumax$, F_taul$, F_taull$, F_Vu$, F_VuLim$
        F_ntaumax = Format(ntaumax, "#0")

        F_taumax = Format(taumax, "#0.00")
        F_taul = Format(taul, "#0.00") : F_taull = Format(taull, "#0.00")

        Select Case geom
            Case 1
                If calcc(1) = 1 And calcc(2) = 1 Then
                    msg = "Tau poinconnement = " & F_taumax & " < " & F_taul & " MPa ( combinaison n" & F_ntaumax & " ELU )" : Affichage(msg)
                Else
                    F_Vu = Format(Vu, "#0.00") : F_VuLim = Format(vulim, "#0.00")
                    msg = "Tau poinconnement = " & F_taumax & " < " & F_taul & " MPa ( combinaison n" & F_ntaumax & " ELU )" : Affichage(msg)
                    msg = "Tau cisaillement = " & F_Vu & " < " & F_VuLim & " MPa" : Affichage(msg) '  ( combinaison n" & F_a & " ELU )"
                End If

            Case 2 'semelle filante arm
                If calcc(1) = 1 And calcc(2) = 1 Then
                    msg = "Tau poinconnement = " & F_taumax & " < " & F_taul & " MPa ( combinaison n" & F_ntaumax & " ELU )" : Affichage(msg)
                Else
                    F_Vu = Format(Vu, "#0.00") : F_VuLim = Format(vulim, "#0.00")
                    msg = "Tau poinonnement = " & F_taumax & " < " & F_taul & " MPa ( combinaison n" & F_ntaumax & " ELU )" : Affichage(msg)
                    msg = "Tau cisaillement = " & F_Vu & " < " & F_VuLim & " MPa" : Affichage(msg) ' ( combinaison n" & F_a & " ELU )"
                End If

            Case 3  'semelle filante non arme
                str = "Sans objet" : Affichage(str)
        End Select
        selTextSelectionne.TypeText(vbCrLf)
        str = "II - Etat Limite Ultime de Stabilit de Forme :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        str = "Sans objet . Pas d'excentricit additionnelle prise en compte."
        Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)

        str = "III - Etat Limite d'Equilibre Statique :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)


        str = "III-1 - Condition de non-glissement" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        str = "H/V < 0.5 ----> condition toujours vrifie" : Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)
        str = "III-2 - Condition de stabilit" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        str = "Sans objet" : Affichage(str)
        selTextSelectionne.TypeText(vbCrLf)

        str = "IV - Etat Limite de Service vis  vis de la durabilit :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        Dim assa10, assa50, assb10, assb50 As Double
        Dim F_assa10$, F_assb10$, F_assa50$, F_assb50$
        'Dim nom_TS() As String = {"ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 45", "ST 50", "ST 60", "ST 25C", "ST 40C", "ST 65C"}
        'Dim section_longitudinale() As Single = {1.19, 1.88, 2.57, 2.83, 3.85, 4.24, 5.03, 6.36, 2.57, 3.85, 6.36}
        'Dim section_transversale() As Single = {1.19, 1.28, 1.28, 1.28, 1.28, 1.68, 1.68, 2.51, 2.57, 3.85, 6.36}
        F_assa = Format(assa * 10000, "##0.00")
        F_assb = Format(assb * 10000, "##0.00")

        Select Case fis
            Case 1
                msg = "Fissuration non prjudiciable . Pas de majoration de la section d'acier ." : Affichage(msg)
            Case 2
                assa10 = assa / 1.1 : assb10 = assb / 1.1
                F_assa10 = Format(assa10 * 10000, "##0.00") : F_assb10 = Format(assb10 * 10000, "##0.00")
                Select Case Type_acier
                    Case 1 'TS
                        Select Case nbLit
                            Case 1  '1 lit
                                If geom = 2 Then
                                    asaa = section_longitudinale(NLit_TS(1))
                                Else
                                    asaa = section_longitudinale(NLit_TS(1)) * b
                                End If
                                F_asaa = Format(asaa, "#0.00")
                                asbb = section_transversale(NLit_TS(1)) * a
                                If nbarB <> 0 Then asbb = asbb / 10000 + nbarB * ((phib) ^ 2) * PI / 4 : asbb = asbb * 10000
                                F_asbb = Format(asbb, "#0.00")
                                msg = "Fissuration prjudiciable . Majoration des sections d'acier de 10% ." : Affichage(msg)
                                msg = "Aciers suivant cot A :" : Affichage(msg)
                                msg = "acier thorique = " & F_assa10 & " x 1.10 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                                msg = "Aciers suivant cot B :" : Affichage(msg)
                                msg = "acier thorique = " & F_assb10 & " x 1.10 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)

                            Case 2  '2 lits
                                If geom = 2 Then
                                    asaa = section_longitudinale(NLit_TS(2))
                                Else
                                    asaa = section_longitudinale(NLit_TS(2)) * b
                                End If
                                asbb = section_transversale(NLit_TS(2)) * a
                                If geom = 2 Then
                                    asaa = section_longitudinale(NLit_TS(3)) + asaa
                                Else
                                    asaa = (section_longitudinale(NLit_TS(3)) * b) + asaa
                                End If
                                asbb = section_transversale(NLit_TS(3)) * a + asbb
                                F_asaa = Format(asaa, "#0.00")
                                F_asbb = Format(asbb, "#0.00")
                                msg = "Fissuration prjudiciable . Majoration des sections d'acier de 10% ." : Affichage(msg)
                                msg = "Aciers suivant cot A :" : Affichage(msg)
                                msg = "acier thorique = " & F_assa10 & " x 1.10 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                                msg = "Aciers suivant cot B :" : Affichage(msg)
                                msg = "acier thorique = " & F_assb10 & " x 1.10 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)
                        End Select
                    Case 2 'HA
                        asaa = nbarA * ((phiA) ^ 2) * PI / 4  ' en m2
                        asbb = nbarB * ((phib) ^ 2) * PI / 4
                        F_asaa = Format(asaa * 10000, "##0.00") : F_asbb = Format(asbb * 10000, "##0.00")
                        msg = "Fissuration prjudiciable . Majoration des sections d'acier de 10% ." : Affichage(msg)
                        msg = "Aciers suivant cot A :" : Affichage(msg)
                        msg = "acier thorique = " & F_assa10 & " x 1.10 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                        msg = "Aciers suivant cot B :" : Affichage(msg)
                        msg = "acier thorique = " & F_assb10 & " x 1.10 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)
                End Select
            Case 3
                assa50 = assa / 1.5 : assb50 = assb / 1.5
                F_assa50 = Format(assa50 * 10000, "##0.00") : F_assb50 = Format(assb50 * 10000, "##0.00")
                Select Case Type_acier
                    Case 1 'TS
                        Select Case nbLit
                            Case 1  '1 lit
                                If geom = 2 Then
                                    asaa = section_longitudinale(NLit_TS(1))
                                Else
                                    asaa = section_longitudinale(NLit_TS(1)) * b
                                End If
                                F_asaa = Format(asaa, "#0.00")
                                asbb = section_transversale(NLit_TS(1)) * a
                                If nbarB <> 0 Then asbb = asbb / 10000 + nbarB * ((phib) ^ 2) * PI / 4 : asbb = asbb * 10000
                                F_asbb = Format(asbb, "#0.00")
                                msg = "Fissuration trs prjudiciable . Majoration des sections d'acier de 50% ." : Affichage(msg)
                                msg = "Aciers suivant cot A :" : Affichage(msg)
                                msg = "acier thorique = " & F_assa50 & " x 1.50 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                                msg = "Aciers suivant cot B :" : Affichage(msg)
                                msg = "acier thorique = " & F_assb50 & " x 1.50 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)
                            Case 2  '2 lits
                                If geom = 2 Then
                                    asaa = section_longitudinale(NLit_TS(2)) + section_longitudinale(NLit_TS(3))
                                Else
                                    asaa = (section_longitudinale(NLit_TS(2)) + section_longitudinale(NLit_TS(3))) * b
                                End If
                                asbb = (section_transversale(NLit_TS(2)) + section_transversale(NLit_TS(3))) * a
                                F_asaa = Format(asaa, "#0.00")
                                F_asbb = Format(asbb, "#0.00")
                                msg = "Fissuration trs prjudiciable . Majoration des sections d'acier de 50% ." : Affichage(msg)
                                msg = "Aciers suivant cot A :" : Affichage(msg)
                                msg = "acier thorique = " & F_assa50 & " x 1.50 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                                msg = "Aciers suivant cot B :" : Affichage(msg)
                                msg = "acier thorique = " & F_assb50 & " x 1.50 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)
                        End Select
                    Case 2 'HA
                        asaa = nbarA * ((phiA) ^ 2) * PI / 4  ' en m2
                        asbb = nbarB * ((phib) ^ 2) * PI / 4
                        F_asaa = Format(asaa * 10000, "##0.00") : F_asbb = Format(asbb * 10000, "##0.00")
                        msg = "Fissuration trs prjudiciable . Majoration des sections d'acier de 50% ." : Affichage(msg)
                        msg = "Aciers suivant cot A :" : Affichage(msg)
                        msg = "acier thorique = " & F_assa50 & " x 1.50 = " & F_assa & " < acier prvu = " & F_asaa : Affichage(msg)
                        msg = "Aciers suivant cot B :" : Affichage(msg)
                        msg = "acier thorique = " & F_assb50 & " x 1.50 = " & F_assb & " < acier prvu = " & F_asbb : Affichage(msg)
                End Select
        End Select

        selTextSelectionne.TypeText(vbCrLf)

        str = "V - Etat Limite de Service vis  vis des dformations :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        Dim F_st, F_sc, F_sd As String
        If Tass = False Then
            msg = "Aucun calcul de tassement effectu." : Affichage(msg)
        Else
            F_sd = Format(Sd * 1000, "##0") : F_sc = Format(Sc * 1000, "##0") : F_st = Format(St * 1000, "##0")
            msg = "L'valuation des tassements est ralis  partir des essais pressiomtriques suivant les prescriptions du DTU 13.12." : Affichage(msg)
            msg = "Le tassement de consolidation est gal  " & F_sc & " mm." : Affichage(msg)
            msg = "Le tassement dviatorique est gal  " & F_sd & " mm." : Affichage(msg)
            msg = "Le tassement total est gal  " & F_st & " mm." : Affichage(msg)
        End If

        '''''''Dim finSlection As Integer = selTextSelectionne.Range.End

        ''''''''If nIndex < tbDonnees.GetUpperBound(0) Then
        ''''''''    If cDerniereLettre = Mid(tbDonnees(nIndex + 1).sNom, 1, 1) Then
        'Fermeture de l'lve par une bordure infrieure
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).Visible = True
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).Color = Word.WdColor.wdColorBlue
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Borders.Item(Word.WdBorderType.wdBorderBottom).LineWidth = Word.WdLineWidth.wdLineWidth225pt
        ''''''''    End If
        ''''''''End If

        ''''''''ThisDocument.Range(dbutSlection, finSlection).Select()
        '''''''ThisApplication.Selection.ParagraphFormat.KeepWithNext = CInt(True)
        '''''''selTextSelectionne.SetRange(ThisDocument.Range.End, ThisDocument.Range.End)
    End Sub
    Private Sub Affichage(ByVal toto As String)
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 9
    End Sub
    Private Sub Affichage1(ByVal toto As String) 'taille 10, gras
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 10
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = CInt(True)
    End Sub
    Private Sub Affichage2(ByVal toto As String) 'taille 9, soulign
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        With ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1)
            .Range.Font.Size = 9
            .Range.Underline = Word.WdUnderline.wdUnderlineSingle
        End With
    End Sub
End Module
