Module Dispo_constructives
    Friend WithEvents ThisApplication As Word.Application
    Friend WithEvents ThisDocument As Word.Document
    Private selTextSelectionne As Word.Selection
    Private cDerniereLettre As Char
    Public Sub Note_Constructive()
        Try
            CreationDocument()
            InitialisationDocument()
            EcrireFichier()
            'Affiche Word
            ThisApplication.Visible = True

        Catch ex As Exception
            If Err.Number = 5825 Then
                'Normal => Objet Word detruit (surement du a la fermeture du formulaire pendant l'execution)
            Else
                DestructionDocument()
                Throw ex
            End If
        End Try
    End Sub
    Private Sub CreationDocument()
        'rtbEtat.AppendText("Cration de l'application word et du document." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        DestructionDocument() 'Detruit les variabble pour ne pas cr de document orphelin si on clique 2 fois sur le bouton
        ThisApplication = New Word.Application
        ThisApplication.Visible = False 'Masque Word
        ThisDocument = ThisApplication.Documents.Add 'Ajoute un document
    End Sub
    Private Sub InitialisationDocument()
        'rtbEtat.AppendText("Mise en forme du document Word." & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        'Application.DoEvents()

        ThisDocument.Range.Font.Name = "arial" 'Defini la police de caractre
        ThisDocument.PageSetup.TextColumns.SetCount(1) 'Impose 1 colonnes au document
        'ThisDocument.PageSetup.TextColumns.LineBetween = CInt(True) 'Insert une ligne verticale entre chaque colonne
        ThisDocument.PageSetup.OddAndEvenPagesHeaderFooter = CInt(True) 'Indique que les Pages paires et impaires seront traites diffrement (pour les entetes et pieds de page ici)

        'Definit les entetes des pages paires
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Text = "Poteau en bton arm: note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10

        'Definit les entetes des pages impaires
        'les 2 tabulation aligne automatique le texte a droite sur les TabStop Automatique de Word (le premier est un centrage)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Text = vbTab & vbTab & "Note de calcul"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Headers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Definit les entetes des pages paires et impaire
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterEvenPages).Range.Font.Size = 10
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Name = "arial"
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Italic = CInt(True)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).Range.Font.Size = 10

        'Ajoute les numro de page sur l'exterieus des page dans les pied de page
        'Force le redemarrage du comptage de la section (ici une seule section celle par default donc tous le docuemnt)
        'Le redemarrage commence a 34
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.Add(Word.WdPageNumberAlignment.wdAlignPageNumberOutside)
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.RestartNumberingAtSection = True
        ThisDocument.Sections.Item(1).Footers.Item(Word.WdHeaderFooterIndex.wdHeaderFooterPrimary).PageNumbers.StartingNumber = 1

        ThisDocument.Range.Select() 'Defini "selTextSelectionne" comme une plage recouvrant tout le document
        selTextSelectionne = ThisApplication.Selection
    End Sub
    Private Sub DestructionDocument()
        'rtbEtat.AppendText("Destruction des objets utiliss" & vbNewLine)
        'Me.Refresh()
        'Me.Update()
        Application.DoEvents()

        If Not (ThisApplication Is Nothing) Then
            Try
                'Ferme l'application sans enregistr le document
                ThisApplication.Quit(Word.WdSaveOptions.wdDoNotSaveChanges)
            Catch ex As System.Runtime.InteropServices.COMException
                'l'application a t ferm par l'utilisateur
            End Try
        End If
        'tbDonnees = Nothing
        ThisDocument = Nothing
        ThisApplication = Nothing
    End Sub

    Private Sub EcrireFichier()
        Dim str As String
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count).TabStops.Add((1000 / 352.7 * 75), Word.WdTabAlignment.wdAlignTabRight)
        selTextSelectionne.TypeText(vbTab)

        selTextSelectionne.TypeText("Dispositions constructives")
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = 0
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Color = Word.WdColor.wdColorBlue
        'ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 14
        selTextSelectionne.TypeText(vbCrLf)

        Str = "I - Matriaux :"
        selTextSelectionne.TypeText(Str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)


        Str = "I-1 - Bton" : Affichage2(Str)
        selTextSelectionne.TypeText(vbCrLf)
        msg = "Rsistance du bton : " & CStr(fc) & " MPa" : Affichage(msg)
        msg = "Enrobage : " & CStr(enr * 100) & " cm" : Affichage(msg)
        Select Case fis
            Case 1 'peu prjudiciable
                msg = "Fissuration peu prjudiciable" : Affichage(msg)
            Case 2 'prjudiciable
                msg = "Fissuration prjudiciable" : Affichage(msg)
            Case 3
                msg = "Fissuration trs prjudiciable" : Affichage(msg)
        End Select
        selTextSelectionne.TypeText(vbCrLf)
        str = "I-2 - Acier" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Select Case Type_acier
            Case 1 'TS
                msg = "Acier de type Treillis soud" : Affichage(msg)
                msg = "Nombre de lit autorise : " & CStr(nbLit) : Affichage(msg)
            Case 2 'HA
                msg = "Acier de type barres HA" : Affichage(msg)
        End Select
        msg = "Rsistance acier : " & CStr(fe) & " MPa" : Affichage(msg)
        selTextSelectionne.TypeText(vbCrLf)
        str = "I-3 - Sols" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        msg = "Rsistance de calcul du sol  l'ELU: " & CStr(q) & " MPa" : Affichage(msg)
        Select Case Sism
            Case 1 'sismique
                msg = "Semelle en zone sismique" : Affichage(msg)
            Case 2 'non sismique
                msg = "Semelle en zone non sismique" : Affichage(msg)
        End Select
        selTextSelectionne.TypeText(vbCrLf)
        str = "II - Dispositions gomtriques :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        Select Case geom
            Case 1
                msg = "Semelle rectangulaire sous poteau rectangulaire" : Affichage(msg)
            Case 2
                msg = "Semelle filante arme" : Affichage(msg)
            Case 3
                msg = "Semelle filante non arm" : Affichage(msg)
                Select Case Position_chainage
                    Case 1
                        msg = "Chainage dans le mur" : Affichage(msg)
                    Case 2
                        msg = "Chainage dans la semelle" : Affichage(msg)
                End Select
        End Select

        Select Case choix
            Case 1
                msg = "le calcul est effectu avec les ctes a,b et h libres." : Affichage(msg)
            Case 2
                msg = "le calcul est effectu avec les ctes a limite, b et h libres." : Affichage(msg)
                msg = "Cte a limite = " & CStr(aL) & " m" : Affichage(msg)
            Case 3
                msg = "le calcul est effectu avec les ctes a impose, b et h libres." : Affichage(msg)
                msg = "Cte a impose = " & CStr(aL) & " m" : Affichage(msg)
            Case 4
                msg = "le calcul est effectu avec les ctes a et b limites, h libre." : Affichage(msg)
                msg = "Cte a limite = " & CStr(aL) & " m" : Affichage(msg)
                msg = "Cte b limite = " & CStr(bL) & " m" : Affichage(msg)
            Case 5
                msg = "le calcul est effectu avec les ctes a impose, b limite et h libre." : Affichage(msg)
                msg = "Cte a impose = " & CStr(aL) & " m" : Affichage(msg)
                msg = "Cte b limite = " & CStr(bL) & " m" : Affichage(msg)
            Case 6
                msg = "le calcul est effectu avec les ctes a impose, b impose et h libre." : Affichage(msg)
                msg = "Cte a impose = " & CStr(aL) & " m" : Affichage(msg)
                msg = "Cte b impose = " & CStr(bL) & " m" : Affichage(msg)
            Case 7
                msg = "le calcul est effectu avec les ctes a impose, b impose et h impose." : Affichage(msg)
                msg = "Cte a impose = " & CStr(aL) & " m" : Affichage(msg)
                msg = "Cte b impose = " & CStr(bL) & " m" : Affichage(msg)
                msg = "Cte h impose = " & CStr(hL) & " m" : Affichage(msg)
        End Select
        selTextSelectionne.TypeText(vbCrLf)
        str = "III - Chargements :"
        selTextSelectionne.TypeText(str)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Underline = Word.WdUnderline.wdUnderlineSingle
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 11
        selTextSelectionne.TypeText(vbCrLf)
        str = "3-1 - A l'ELU" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        Dim i As Integer
        i = 1
        Do While p(1, i) <> 0
            msg = "Combinaison n" & CStr(i) : Affichage(msg)
            msg = "N= " & CStr(p(1, i)) & " Mx= " & CStr(mx(1, i)) & " My= " & CStr(mty(1, i)) & " Hx=" & CStr(Hx(1, i)) & " Hy=" & CStr(Hy(1, i)) : Affichage(msg)
            i = i + 1
        Loop
        selTextSelectionne.TypeText(vbCrLf)
        str = "3-2 - A l'ELS" : Affichage2(str)
        selTextSelectionne.TypeText(vbCrLf)
        If p(2, 1) = 0 Then
            msg = "Pas de combinaison renseigne  l'ELS" : Affichage(msg)
        Else
            i = 1
            Do While p(2, i) <> 0
                msg = "Combinaison n" & CStr(i) : Affichage(msg)
                msg = "N= " & CStr(p(2, i)) & " Mx= " & CStr(mx(2, i)) & " My= " & CStr(mty(2, i)) & " Hx=" & CStr(Hx(2, i)) & " Hy=" & CStr(Hy(2, i)) : Affichage(msg)
                i = i + 1
            Loop
        End If

    End Sub
    Private Sub Affichage(ByVal toto As String)
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 9
    End Sub
    Private Sub Affichage1(ByVal toto As String) 'taille 10, gras
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Font.Size = 10
        ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1).Range.Bold = CInt(True)
    End Sub
    Private Sub Affichage2(ByVal toto As String) 'taille 9, soulign
        selTextSelectionne.TypeText(toto)
        selTextSelectionne.TypeParagraph()
        With ThisDocument.Paragraphs.Item(ThisDocument.Paragraphs.Count - 1)
            .Range.Font.Size = 9
            .Range.Underline = Word.WdUnderline.wdUnderlineSingle
        End With
    End Sub
End Module
