Imports System.IO
Module Lecture
    'Lecture et criture du fichier de donnes
    Dim title As String = "SEMELLE BA : module de lecture"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly

#Region " Code de lecture du fichier de donnes "

    Public Sub Lecture_fichier(ByRef Donnee_OK As Boolean)
        ' The StreamReader must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamReader As StreamReader
        Dim i, k, choixx As Integer
        Dim toto, msg As String
        choixx = 0
        Try
            Donnee_OK = True
            i = 1 : k = 1
            myStreamReader = File.OpenText(l_strFileName)
            toto = myStreamReader.ReadLine
            If toto <> "" Then Call titre(toto)
            While toto <> ""
                i = i + 1
                toto = myStreamReader.ReadLine
                If toto <> "" Then
                    Select Case choixx
                        Case 0
                            Call Donnees(toto, choixx, Donnee_OK)
                            If Donnee_OK = False Then Exit Sub
                        Case 1 'lecture des hypothses
                            Call Hypo(toto, k, choixx)
                        Case 2 'lecture gomtrie
                            Call Geometrie(toto, k, choixx)
                        Case 3 'lecture des charges
                            Call Charges(toto, k, choixx)
                        Case 4 ' sol tassement
                            Call sol_tassement(toto, k, choixx)
                    End Select
                End If
            End While

        Catch exc As Exception
            ' Show the exception to the user.
            MsgBox("Erreur de lecture du fichier" + vbCrLf + "Exception: " + exc.Message, style, title)
            Donnee_OK = False
        Finally
            ' Close the object if it has been created.
            If Not myStreamReader Is Nothing Then
                myStreamReader.Close()
            End If
        End Try
    End Sub

    Private Sub titre(ByVal toto As String)
        Dim i, position As Integer
        Dim msg As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'crire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        position = InStr(toto, "semelle") 'dtermine l'emplacement de semelle
        If position = 0 Then
            msg = "Il manque l'entte Semelle dans votre fichier."
            MsgBox(msg, style, title)
        End If
    End Sub
    Private Sub Donnees(ByVal toto As String, ByRef choixx As Integer, ByRef Donnee_OK As Boolean)
        Dim blanc(15), i, j, k, position As Integer
        Dim msg, titi(10), tata, tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'crire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        tata = titi(1)
        If titi(1) = "'" Then Exit Sub 'cette chaine correspond  un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tata = titi(j) : tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                tata = titi(j)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                tata = titi(j + 1)
                titi(j + 1) = Trim(titi(j + 1)) : tata = titi(j + 1)
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'vrification si la chaine est un dbut de paragraphe
        'la chaine est un dbut de paragraphe
        tutu = Microsoft.VisualBasic.Left(titi(1), 3)
        Select Case tutu
            Case "hyp"
                choixx = 1
            Case "geo"
                choixx = 2
            Case "go"
                choixx = 2
            Case "cha"
                choixx = 3
            Case "sol"
                choixx = 4
            Case Else
                Donnee_OK = False
        End Select

    End Sub
    Private Sub Hypo(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(11), i, j, noe, position As Integer
        Dim ot As Double
        Dim msg, titi(11), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        Select Case k
            Case 1 'ligne 1 du paragraphe hypothse
                fc = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                gamaB = CDbl(titi(2)) : fis = CInt(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                dsb = CDbl(titi(4))
            Case 2
                Type_acier = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                fe = CInt(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                gamaS = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                espmin = CDbl(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
                espMax = CDbl(titi(5)) : If IsNumeric(titi(6)) = False Then Call Verification_point(titi(6))
                enr = CDbl(titi(6)) : ancrage = CInt(titi(7)) : angle1 = CInt(titi(8)) : angle2 = CInt(titi(9)) : angle3 = CInt(titi(10))
            Case 3 'sol
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                q = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                hf = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                dss = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                ELU = CDbl(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
                ELS = CDbl(titi(5))
            Case 4
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                tol1 = CDbl(titi(1)) : DTU = CBool(titi(2)) : CCTG = CBool(titi(3))

        End Select

        k = k + 1
        If k = 5 Then
            k = 1
            choixx = 0
        End If
    End Sub
    Private Sub Geometrie(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0

        Select Case k
            Case 1 'ligne 1 du paragraphe geometrie
                nomaffaire = titi(1) : ingenieur = titi(2)
            Case 2
                choix = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                aL = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                bL = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                hL = CDbl(titi(4))
            Case 3 'semelle
                geom = CInt(titi(1)) : nom = titi(2) : nsem = CInt(titi(3))
            Case 4 'poteau
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                pa = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                pb = CDbl(titi(2)) : nbag = CInt(titi(3)) : nbap = CInt(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
                Ha = CDbl(titi(5))
            Case 5 ' superstructure
                Voile = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Lvoile = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                HAvoile = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                espvoile = CDbl(titi(4)) : Position_chainage = CInt(titi(5)) : Attente = CBool(titi(6)) : Rang = CInt(titi(7))
            Case 6
                crochet_TS = CBool(titi(1)) : nbLit = CInt(titi(2))
            Case 7
                Ferraillage_haut = CBool(titi(1))
        End Select
        k = k + 1
        If k = 8 Then
            k = 1
            choixx = 0
        End If
    End Sub

    Private Sub Charges(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(10), i, j, position As Integer
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Try
        If k > 4 Then j = 2 Else j = 1 'j = CInt(Int((k - 1) / 4)) : If j = 0 Then j = 1
        If k > 4 Then i = k - 4 Else i = k
        If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
        p(j, i) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
        mx(j, i) = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
        mty(j, i) = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
        Hx(j, i) = CDbl(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
        Hy(j, i) = CDbl(titi(5)) : If IsNumeric(titi(6)) = False Then Call Verification_point(titi(6))

        k = k + 1
        If k = 9 Then
            k = 1
            choixx = 0
        End If
        'Catch
        '    k = 1
        '    choixx = 0
        'End Try
    End Sub
    Private Sub Sol_tassement(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(15), i, j, noe, position As Integer
        Dim ot As Double
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0

        Select Case k
            Case 1
                Tass = CBool(titi(1))
            Case 2
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                alpha = CDbl(titi(1))
            Case Else
                i = k - 2
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                EM(i) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                z(i) = CDbl(titi(2))
        End Select
        k = k + 1
        If k = 19 Then
            k = 1
            choixx = 0
        End If
    End Sub

    Private Sub Verification_point(ByRef tata As String)
        Dim position As Integer
        position = InStr(1, tata, ".")
        If position <> 0 Then
            Mid(tata, position) = ","
        End If
    End Sub
#End Region

#Region " Code d'criture du fichier de donnes "
    Public Sub Ecriture_Fichier()
        ' The StreamWriter must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamWriter As StreamWriter
        Dim i, i1, i2, i3, i5(3), i6(3), j As Integer
        ' Ensure that the creation of the new StreamWriter is wrapped in a 
        '   Try-Catch block, since an invalid filename could have been used.
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(l_strFileName)
            'myStreamWriter = File.AppendText()

            ' Write the entire contents of the txtFileText text box
            '   to the StreamWriter in one shot.

            myStreamWriter.WriteLine("Semelle bton arm")
            myStreamWriter.WriteLine("Hypothese")
            myStreamWriter.WriteLine(fc & " " & gamaB & " " & fis & " " & dsb)
            myStreamWriter.WriteLine(Type_acier & " " & fe & " " & gamaS & " " & espmin & " " & espMax & " " & enr & " " & ancrage & " " & angle1 & " " & angle2 & " " & angle3)
            myStreamWriter.WriteLine(q & " " & hf & " " & dss & " " & ELU & " " & ELS)
            myStreamWriter.WriteLine(tol1 & " " & DTU & " " & CCTG)
            'geometrie
            myStreamWriter.WriteLine("Geometrie")
            myStreamWriter.WriteLine(nomaffaire & " " & ingenieur)
            myStreamWriter.WriteLine(choix & " " & aL & " " & bL & " " & hL)
            myStreamWriter.WriteLine(geom & " " & nom & " " & nsem)
            myStreamWriter.WriteLine(pa & " " & pb & " " & nbag & " " & nbap & " " & Ha)
            myStreamWriter.WriteLine(Voile & " " & Lvoile & " " & HAvoile & " " & espvoile & " " & Position_chainage & " " & Attente & " " & Rang)
            myStreamWriter.WriteLine(crochet_TS & " " & nbLit)
            myStreamWriter.WriteLine(Ferraillage_haut)
            'charges
            myStreamWriter.WriteLine("Charges")
            For j = 1 To 2
                For i = 1 To 4
                    myStreamWriter.WriteLine(p(j, i) & " " & mx(j, i) & " " & mty(j, i) & " " & Hx(j, i) & " " & Hy(j, i))
                Next i
            Next j
            'sol
            myStreamWriter.WriteLine("Sol")
            myStreamWriter.WriteLine(Tass)
            myStreamWriter.WriteLine(alpha)
            For i = 1 To 16
                myStreamWriter.WriteLine(EM(i) & " " & z(i))
            Next i
            ' Flush the stream to ensure everything is flushed
            myStreamWriter.Flush()
        Catch exc As Exception
            MsgBox("File could not be opened or written to." + vbCrLf + _
                "Please verify that the filename is correct, " + _
                "and that you have read permissions for the desired " + _
                "directory." + vbCrLf + vbCrLf + "Exception: " + exc.Message)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then
                myStreamWriter.Close()
            End If
        End Try
        'myStreamReader = File.OpenText(l_strFileName)

        'toto = myStreamReader.ReadLine
      
    End Sub
#End Region

End Module
